//
// System.NullReferenceException.cs
//
// Authors:
//   Joe Shaw (joe@ximian.com)
//   Duncan Mak (duncan@ximian.com)
//   Andreas Nahr (ClassDevelopment@A-SoftTech.com)
//
// (C) 2001 Ximian, Inc.  http://www.ximian.com
//
import { SystemException, markType } from "./type";
import { Locale } from "./Locale";
export class NullReferenceException extends SystemException {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    super(1, Locale.a("A null value was found where an object instance was required."));
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(1, c);
                }
                break;
            case 2:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    super(2, c, d);
                }
                break;
        }
    }
}
NullReferenceException.$t = markType(NullReferenceException, 'NullReferenceException', SystemException.$);
//# sourceMappingURL=NullReferenceException.js.map